<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <s:div id="globalDiv"><h1>#{messages['gazelle.ordermanager.LaboratoryOrderFiller']}</h1>
                <s:div id="notFoundDiv" styleClass="gzl-alert gzl-alert-orange"
                       rendered="#{workOrderSender.selectedWorkOrder == null and workOrderSender.selectedSpecimen == null}">
                    <h:outputText value="#{messages['gazelle.ordermanager.NoWorkOrderNorSpecimenSelected']}"/>
                </s:div>
                <s:div id="mainDiv">
                    <gri:panel pid="mainPanel"
                               rendered="#{workOrderSender.selectedWorkOrder != null or workOrderSender.selectedSpecimen != null}">
                        <f:facet name="header">#{messages['gazelle.ordermanager.SendWorkOrderCreationNotification']}
                        </f:facet><!-- SUT Selection -->
                        <ui:include src="/configuration/initiatorFrame.xhtml">
                            <ui:param name="actorKeyword" value="AM"/>
                            <ui:param name="diagramImg" value="/diag/LAB_OF_AM_send.png"/>
                            <ui:param name="currentConfig" value="#{userPreferencesManagerBean.selectedSUT}"/>
                            <ui:param name="simuFacility" value="#{messages['gazelle.ordermanager.IHEGazelle']}"/>
                            <ui:param name="simuApplication" value="#{messages['gazelle.ordermanager.OMLABOF']}"/>
                            <ui:param name="sectionsToReRender"
                                      value="configDiv"/>
                            <ui:param name="simulatorConfigurationName"
                                      value="#{messages['gazelle.ordermanager.LaboratoryOrderFiller']}"/>
                            <ui:param name="availableSuts" value="#{workOrderSender.availableSuts}"/>
                        </ui:include>
                        <dl class="dl-horizontal">
                            <s:decorate template="/layout/display/_data_list_item.xhtml"
                                        rendered="#{workOrderSender.hl7Messages == null}">
                                <ui:define name="label">#{messages['gazelle.ordermanager.MessageStructure']}</ui:define>
                                <h:outputText value="#{workOrderSender.messageStructure}"/>
                            </s:decorate>
                        </dl>
                        <br/>
                        <s:div rendered="#{workOrderSender.hl7Messages == null}"
                               id="configDiv">
                            <!-- display details about work order/specimen depending on the message structure -->
                            <gri:panel>
                                <f:facet name="header">
                                    <s:div>
                                        <h:outputText rendered="#{workOrderSender.selectedWorkOrder != null}"
                                                      value="#{messages['gazelle.ordermanager.WorkOrderDetails']}"/>
                                        <h:outputText rendered="#{workOrderSender.selectedSpecimen != null}"
                                                      value="#{messages['gazelle.ordermanager.SpecimenDetails']}"/>
                                    </s:div>
                                </f:facet>
                                <s:div rendered="#{workOrderSender.selectedWorkOrder != null}">
                                    <dl class="dl-horizontal">
                                        <s:decorate template="/layout/display/_data_list_item.xhtml"
                                                    rendered="#{workOrderSender.selectedWorkOrder.encounter != null}">
                                            <ui:define name="label">#{messages['gazelle.ordermanager.Patient']}
                                            </ui:define>
                                            <h:outputText
                                                    value="#{workOrderSender.selectedWorkOrder.encounter.patient.firstName} #{workOrderSender.selectedWorkOrder.encounter.patient.lastName}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml"
                                                    rendered="#{workOrderSender.selectedWorkOrder.encounter != null}">
                                            <ui:define name="label">#{messages['gazelle.ordermanager.VisitNumber']}
                                            </ui:define>
                                            <h:outputText
                                                    value="#{workOrderSender.selectedWorkOrder.encounter.visitNumber}"/>
                                        </s:decorate>
                                    </dl>
                                    <f:subview id="subview_3" rendered="#{workOrderSender.selectedWorkOrder != null}">
                                        <ui:include src="/lab/labOrderDetails.xhtml">
                                            <ui:param name="selectedOrder"
                                                      value="#{workOrderSender.selectedWorkOrder}"/>
                                            <ui:param name="enableStatusEdit" value="false"/>
                                        </ui:include>
                                    </f:subview>
                                </s:div>
                                <f:subview id="subview_4" rendered="#{workOrderSender.selectedSpecimen != null}">
                                    <ui:include src="/lab/specimenDetails.xhtml">
                                        <ui:param name="specimen" value="#{workOrderSender.selectedSpecimen}"/>
                                    </ui:include>
                                </f:subview>
                                <f:facet name="footer">
                                    <a4j:commandButton value="#{messages['gazelle.ordermanager.SendMessage']}"
                                                       actionListener="#{workOrderSender.send()}"
                                                       render="globalDiv" styleClass="gzl-btn-blue"/>
                                </f:facet>
                            </gri:panel>
                            <br/><!-- display list of specimens relative to the work order (battery-centric case) -->
                            <gri:panel rendered="#{workOrderSender.selectedWorkOrder != null}">
                                <f:facet name="header">#{messages['gazelle.ordermanager.RelatedSpecimens']}</f:facet>
                                <rich:dataTable value="#{workOrderSender.selectedWorkOrder.specimens}" var="specimen"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                id="specimens4Order" render="ds">
                                    <ui:include src="/lab/specimenColumns.xhtml">
                                        <ui:param name="specimen" value="#{specimen}"/>
                                    </ui:include>
                                    <g:column>
                                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                                        <a4j:commandLink actionListener="#{workOrderSender.removeSpecimen(specimen)}"
                                                         title="#{messages['gazelle.ordermanager.RemoveThisSpecimen']}"
                                                         render="specimens4Order">
                                            <s:span styleClass="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="specimens4Order"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </gri:panel><!-- display list of containers relative to the specimen (specimen-centric case) -->
                            <gri:panel rendered="#{workOrderSender.selectedSpecimen != null}" pid="containersPanel">
                                <f:facet name="header">#{messages['gazelle.ordermanager.RelatedContainers']}</f:facet>
                                <a4j:repeat value="#{workOrderSender.selectedSpecimen.containers}" var="sac"
                                            id="containers4Specimen">
                                    <h:panelGrid columns="10">
                                        <h:outputText value="#{sac.containerIdentifier}"/>
                                        <h:outputText
                                                value=" (#{sac.orders.size()} #{messages['gazelle.ordermanager.Orders']}"
                                                rendered="#{sac.mainEntity or not empty sac.orders}"/>
                                        <a4j:commandLink actionListener="#{workOrderSender.removeContainer(sac)}"
                                                         title="#{messages['gazelle.ordermanager.RemoveThisContainer']}"
                                                         render="containersPanel">
                                            <s:span styleClass="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                    </h:panelGrid>
                                    <rich:dataTable value="#{sac.orders}" var="orc"
                                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                    id="orders4Container" rendered="#{sac.orders != null}" render="ds">
                                        <ui:include src="/common/orderColumns.xhtml">
                                            <ui:param name="managedBean" value="#{workOrderSender}"/>
                                            <ui:param name="currentOrder" value="#{orc}"/>
                                            <ui:param name="displayEncounterInfo" value="true"/>
                                            <ui:param name="enableStatusEdit" value="false"/>
                                        </ui:include>
                                        <g:column>
                                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                                            <a4j:commandLink
                                                    actionListener="#{workOrderSender.removeOrderFromContainer(orc, sac)}"
                                                    title="#{messages['gazelle.ordermanager.RemoveThisContainer']}"
                                                    render="containersPanel">
                                                <s:span styleClass="gzl-icon-trash-o"/>
                                            </a4j:commandLink>
                                        </g:column>
                                        <f:facet name="footer">
                                            <ui:include src="/util/datatableFooter.xhtml">
                                                <ui:param name="dataScrollerId" value="ds"/>
                                                <ui:param name="dataTableId" value="orders4Container"/>
                                            </ui:include>
                                        </f:facet>
                                    </rich:dataTable>
                                </a4j:repeat>
                            </gri:panel>
                            <br/>
                            <gri:panel
                                    rendered="#{workOrderSender.selectedSpecimen != null and not empty workOrderSender.selectedSpecimen.orders}"
                                    pid="relatedOrders">
                                <f:facet name="header">#{messages['gazelle.ordermanager.RelatedWorkOrders']}</f:facet>
                                <rich:dataTable value="#{workOrderSender.selectedSpecimen.orders}" var="orc"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                id="orders4Specimens"
                                                render="ds">
                                    <ui:include src="/common/orderColumns.xhtml">
                                        <ui:param name="managedBean" value="#{workOrderSender}"/>
                                        <ui:param name="currentOrder" value="#{orc}"/>
                                        <ui:param name="displayEncounterInfo"
                                                  value="true"/>
                                    </ui:include>
                                    <g:column>
                                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                                        <a4j:commandLink
                                                actionListener="#{workOrderSender.removeOrderFromSpecimen(orc)}"
                                                title="#{messages['gazelle.ordermanager.RemoveThisContainer']}"
                                                render="relatedOrders">
                                            <s:span styleClass="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="orders4Specimen"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </gri:panel>
                        </s:div><!-- Exchange messages -->
                        <s:div id="hl7MessagesDiv">
                            <gri:panel rendered="#{workOrderSender.hl7Messages != null}">
                                <f:facet name="header">#{messages['gazelle.ordermanager.TestReport']}</f:facet>
                                <ui:include src="/messages/message_table.xhtml">
                                    <ui:param name="hl7Messages" value="#{workOrderSender.hl7Messages}"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton value="#{messages['gazelle.ordermanager.PerformAnotherTest']}"
                                                       action="#{workOrderSender.performAnotherTest()}"
                                                       styleClass="gzl-btn-blue"/>
                                </f:facet>
                            </gri:panel>
                        </s:div>
                    </gri:panel>
                </s:div>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
